# Electrophysiology Manipulator Link

[![PyPI version](https://badge.fury.io/py/ephys-link.svg)](https://badge.fury.io/py/ephys-link)
[![Deploy Documentation](https://github.com/VirtualBrainLab/ephys-link/actions/workflows/deploy-docs.yml/badge.svg)](https://github.com/VirtualBrainLab/ephys-link/actions/workflows/deploy-docs.yml)
[![Pydantic v2](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/pydantic/pydantic/main/docs/badge/v2.json)](https://pydantic.dev)
[![Hatch project](https://img.shields.io/badge/%F0%9F%A5%9A-Hatch-4051b5.svg)](https://github.com/pypa/hatch)
[![Ruff](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/astral-sh/ruff/main/assets/badge/v2.json)](https://github.com/astral-sh/ruff)
[![Checked with pyright](https://microsoft.github.io/pyright/img/pyright_badge.svg)](https://microsoft.github.io/pyright/)

The [Electrophysiology Manipulator Link](https://github.com/VirtualBrainLab/ephys-link)
(or Ephys Link for short) is a Python [Socket.IO](https://socket.io/docs/v4/#what-socketio-is) server that allows any
Socket.IO-compliant application (such
as [Pinpoint](https://github.com/VirtualBrainLab/Pinpoint))
to communicate with manipulators used in electrophysiology experiments.

<img width="100%" src="https://github.com/VirtualBrainLab/ephys-link/assets/82800265/0c7c60b1-0926-4697-a461-221554f82de1" alt="Manipulator and probe in pinpoint moving in sync">

<div class="grid cards" markdown>

-   __:fontawesome-solid-download: Get Started__

    ---

    Install Ephys Link and get started in seconds.


    [:octicons-arrow-right-24: Install](home/installation.md)

-   __:fontawesome-solid-computer: Usage__

    ---

    Learn how to use Ephys Link to control your manipulators.

    [:octicons-arrow-right-24: Usage](usage/starting_ephys_link.md)

-   __:fontawesome-regular-square-plus: Add a Manipulator Platform__

    ---

    Add a new manipulator platform to Ephys Link to enable control.

    [:octicons-arrow-right-24: Develop](development/adding_a_manipulator.md)

-   __:fontawesome-solid-book-open: Learn About Pinpoint__

    ---

    Pinpoint is an experiment planning and automation tool that uses Ephys Link.

    [:octicons-arrow-right-24: Learn More](https://virtualbrainlab.org/pinpoint/installation_and_use.html)
</div>